<?php
/**
 * @brief randomPost, a plugin for Dotclear 2
 *
 * @package Dotclear
 * @subpackage Plugins
 *
 * @author julien mudry and contributors
 *
 * @copyright julien mudry
 * @copyright GPL-2.0 https://www.gnu.org/licenses/gpl-2.0.html
 */
if (!defined('DC_RC_PATH')) { return; }

$this->registerModule(
    "Random Post",
    "Returns a random published post from the blog",
    "julien mudry",
    '1.1.0b',
    [
        'requires'    => [['core', '2.26']],
        'permissions' => dcCore::app()->auth->makePermissions([
            dcAuth::PERMISSION_USAGE,
            dcAuth::PERMISSION_CONTENT_ADMIN,
        ]),
        'type'        => 'plugin',
        'settings'    => [
            'self'    => '',
        ],
        'priority'    => null,
        'details'     => 'https://mudry.org/blog/alias/randomPost',
        'support'     => 'https://codeberg.org/julmud/dc2-randomPost',
        'repository'  => 'https://codeberg.org/julmud/dc2-randomPost/raw/branch/main/dcstore.xml',
    ]
);
